#!/bin/bash

ARG2=$2

cleantools() {
	make -C ../3a_asm clean
	make -C ../3b_sim clean
	make -C ../3c_disasm clean
	rm -f *.s.dthex
}

buildtools() {
	make -C ../3a_asm -j3 all
	make -C ../3b_sim -j3 all
}

runasm() {
	if [ "$ARG2" == ""  ]; then
		echo "runasm: please provide a assembler file"
		exit 1
	fi
	../3a_asm/dtas < $ARG2 > ${ARG2%.s}.dthex
}

runasmbin() {
	if [ "$ARG2" == ""  ]; then
		echo "runasm: please provide a assembler file"
		exit 1
	fi
	../3a_asm/dtas -b < $ARG2 > ${ARG2%.s}_bin.dthex
}

runsim() {
	if [ "$ARG2" == ""  ]; then
		echo "runsim: please provide a dthex file"
		exit 1
	fi
	cd ../3b_sim; ./sim -f ../3_test/$ARG2
}

runasmsim() {
	if [ "$ARG2" == ""  ]; then
		echo "runasm: please provide a assembler file"
		exit 1
	fi
	../3a_asm/dtas < $ARG2 > ${ARG2%.s}.dthex
	cd ../3b_sim; ./sim -f ../3_test/${ARG2%.s}.dthex
}

case $1 in
	clean) cleantools;;
	build) buildtools;;
	asm) runasm;;
	asmbin) runasmbin;;
	sim) runsim;;
	asmsim) runasmsim;;
	*) echo "first argument must be clean|build|"
	   echo "asm <file.s>|asmbin <file.s>|"
	   echo "sim <file.dthex>|asmsim <file.s>"
esac

